#!/usr/bin/env python

############################################################################
#    Copyright (C) 2006 by Hasan Abdel Halim                               #
#    abdelhal@informatik.uni-bonn.de                                       #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
#                                                                          #
#    Date : %date% at %time%                                               #
#    Filename : OperationsManager.py                                                 # 
############################################################################

from qt import QThread, QMutex, QCustomEvent
from Operation import *

class OperationsManager (QThread):
#TODO: encapsulate the mobile within the manager 
    """
      
      :version:
      :author:
    """

    def __init__(self, name, receiver):
        QThread.__init__(self)
        self.operations = []
        self.name = "QObexftp operations Manager"
        self.receiver = receiver
        self.stopped= "false"
        self.mutex = QMutex()

    def add(self, op):
        """
        
    
        @param Operation op : 
        @return  :
        @author
        """
        self.mutex.lock()
        self.operations.append(op)
    
        if not self.running():
            self.start()
          # indication of start
            QThread.postEvent( self.receiver, QCustomEvent(333333) )
        else:
            print "it assumes the thread is running while it is not "
        
        print op.name, " has been added"
        self.mutex.unlock()
  
  
    def setEngine(self, engine):
        self.engine = engine
        print "A new engine has been assigned"

    
    def run(self):
        while 1:
            self.mutex.lock()
          
            if not self.operations:
                self.mutex.unlock()
                break
          
            ops_no = len ( self.operations )
            operation = self.operations.pop()            
            self.mutex.unlock()
    
            if self.stopped == 'true':
                # event for forced stop event 
                QThread.postEvent( self.receiver, QCustomEvent(555555) )
                break   #foreced to stop operation 
            
            event = QCustomEvent(100000)
            event.setData("%d" % ops_no )
            operation.execute(self.engine)
            QThread.postEvent(self.receiver , event)
        
            # finished so send an event to the engine 
        event = QCustomEvent(222222)
        event.setData("%s: done" % (self.name))
        QThread.postEvent(self.receiver, event )
        self.stopped = 'false' # reset urgent flag to avoid race condition

    
    def stop(self):
        self.stopped = 'true'

