#!/usr/bin/env python

############################################################################
#    Copyright (C) 2006 by Hasan Abdel Halim   #
#    abdelhal@informatik.uni-bonn.de   #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import sys
import os.path
import obexftp_interface
from xml.dom.ext.reader import PyExpat
from xml.xpath          import Evaluate

def parse_obex_xml(xml):
	folders_path = 'folder'
	files_path = 'file'
	reader = PyExpat.Reader( )
	result = {
			'folders' : None,
			'files'	: None
			}
	
	""" removes strange ending character 00 """
	xml = xml[:-1]

	dom = reader.fromString(xml)

	folders = Evaluate (folders_path, dom.documentElement)

	flds = []
	for folder in folders:
		fld = {
				'Name' : folder.getAttribute("name"),
				'Label': folder.getAttribute("label"),
				'MEM-Type': folder.getAttribute("mem-type"),
				'User-Perm': folder.getAttribute("user-perm")
				}
		flds.append(fld)

	result['folders'] = flds

	files = Evaluate (files_path, dom.documentElement)

	fls = []
	for file in files:
		fl = {
				'Name' : file.getAttribute("name"),
				'Size' : file.getAttribute("size"),
				'Modified': file.getAttribute("modified"),
				'User-Perm': file.getAttribute("user-perm")
				}
		fls.append(fl)
	
	result['files'] = fls 

	return result

